function MroNotification(device_type, android_sender_id, on_register, on_message)
{
    this.token = null;
    this.on_register = on_register;
    this.on_message = on_message;
    
    this.device_type = device_type;
    this.android_sender_id = android_sender_id;
    
    this.push_notification = window.plugins.pushNotification;
}


MroNotification.prototype.receive_ios_token = function(token)
{
    this.token = token;
    
    this.on_register();
};



MroNotification.prototype.get_name = function()
{
    for(var name in window)
    {
        if(window[name] === this)
        {
            return name;
        }
    }
    return '';
};

function unused_function()
{
    //alert(param);
}


MroNotification.prototype.register = function()
{
    if(this.device_type === 'android')
    {
        this.push_notification.register
        (
            unused_function,
            global_error_handler,
            {
                'senderID': this.android_sender_id,
                'ecb': this.get_name() + '.on_android_notification'
            }
        );
    }
    else
    {
        this.push_notification.register
        (
            this.receive_ios_token,
            global_error_handler,
            {
                'badge': 'true',
                'sound': 'true',
                'alert': 'true',
                'ecb': this.get_name() + '.on_android_notification'
            }
        );
    }
};


MroNotification.prototype.on_android_notification = function(e)
{
    switch(e.event)
    {
        case 'registered':
            if(e.regid.length > 0)
            {
                this.token = e.regid;

                this.on_register();
            }
            break;

        case 'message':
            if(this.on_message && typeof(this.on_message) === 'function') this.on_message();
            break;

        case 'error':
            break;
    }
};


MroNotification.prototype.on_ios_notification = function(e)
{
    if(this.on_message && typeof(this.on_message) === 'function') this.on_message();
    
    if(e.alert)
    {
    }

    if(e.sound)
    {
        //var snd = new Media(e.sound);
        //snd.play();
    }

    if(e.badge)
    {
        //this.push_notification.setApplicationIconBadgeNumber(successHandler, errorHandler, e.badge);
    }
};